#ifndef __BLITTER_H__
#define __BLITTER_H__
/*********************************************************************************************/
#include <ddraw.h>
#include "types.h"
/*********************************************************************************************/
class blitter
	{
	public:
		virtual int init(int /*width*/,int /*height*/,int /*colors*/,HWND /*wnd*/){return(0);}
		virtual void kill(){}
		virtual void setcolor(int /*num*/,u8 /*r*/,u8 /*g*/,u8 /*b*/){}
		virtual void getcolor(int /*num*/,u8 * /*r*/,u8 * /*g*/,u8 * /*b*/){}
		virtual void resize(){}
		virtual u8 *framestart(){return(0);}
		virtual void framestop(){}
		virtual void getpalette(void **dest){*dest = 0;}
		virtual void setpalette(void * /*dest*/){}
	};
class gdiblitter:public blitter
	{
	private:
		BITMAPINFO bmpinfo;
		RECT rect;
		HWND hwnd;
		HDC hdc;
		HBITMAP hbitmap;
		int bpp;
		void *dest;
		void *palette;
		u8 *screen;
		int w,h;
		int numcolors;
	public:
		gdiblitter();
		~gdiblitter();
		int init(int width,int height,int colors,HWND wnd);
		void kill();
		void setcolor(int num,u8 r,u8 g,u8 b);
		void getcolor(int num,u8 *r,u8 *g,u8 *b);
		void resize();
		u8 *framestart();
		void framestop();
		void getpalette(void **dest);
		void setpalette(void *dest);
	};
class dxblitter:public blitter
	{
	private:
		DDSURFACEDESC2 ddsd;
		LPDIRECTDRAW7 lpdd;
		LPDIRECTDRAWSURFACE7 lpddsprimary;
		LPDIRECTDRAWSURFACE7 lpddsback;
		LPDIRECTDRAWCLIPPER lpclipper;
		RECT rect;
		HWND hwnd;
		int bpp;
		void *dest;
		void *palette;
		u8 *screen;
		int w,h;
		int numcolors;
	public:
		dxblitter();
		~dxblitter();
		int init(int width,int height,int colors,HWND wnd);
		void kill();
		void setcolor(int num,u8 r,u8 g,u8 b);
		void getcolor(int num,u8 *r,u8 *g,u8 *b);
		void resize();
		u8 *framestart();
		void framestop();
		void getpalette(void **dest);
		void setpalette(void *dest);
	};
/*********************************************************************************************/
#endif