// breem.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "breem.h"

#include "MainFrm.h"
#include "types.h"
#include "blitter.h"
#include "romviewer.h"
#include "debugger.h"
#include "settings.h"
#include "unzip\unzip.h"
//#include "ay8910\ay8910.h"
//#include "btime_dipswitches.h"
#include "link.h"
//#include "games.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//from games.dll
extern "C" void setgameinfo(gameinfo_t *info);
extern "C" void loaddips(CRegKey *rk);
extern "C" void savedips(CRegKey *rk);
extern "C" romset_t **getromsets();
extern "C" void dipsettings();
/////////////////////////////////////////////////////////////////////////////
gameinfo_t info;
CStringList messages;
int maxmessages = 500;
settings_t settings;
romset_t *romset;
int romsetinited;
/////////////////////////////////////////////////////////////////////////////
dead6502data cpu1data,cpu2data;
u8 *cpumem[3]; //64k for each cpu, and 64k for main cpu decoded opcodes
u8 *vrom[3];
//u8 videocontrol,soundlatch;
//u8 scroll1,scroll2;
u8 vblank;
u8 reg4000,reg4001,reg4002;

extern "C" void emumessage(char *msg,...)
{
va_list args;
char debugmsg[1024];
int i,sl;

va_start(args,msg);
vsprintf(debugmsg,msg,args);
va_end(args);
sl = strlen(debugmsg);
for(i=0;i<sl;i++)
	{
	if(debugmsg[i] == '\n')
		debugmsg[i] = ' ';
	}
if(messages.GetCount() > maxmessages)
	messages.RemoveAt(messages.FindIndex(0));
messages.AddTail(debugmsg);
if(theApp.messagesdlg)
	theApp.messagesdlg->addstring(debugmsg);
}

/////////////////////////////////////////////////////////////////////////////
// CBreemApp

BEGIN_MESSAGE_MAP(CBreemApp, CWinApp)
	//{{AFX_MSG_MAP(CBreemApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_VIEW_DEBUGGER, OnViewDebugger)
	ON_COMMAND(ID_VIEW_ROMVIEWER, OnViewRomviewer)
	ON_COMMAND(ID_VIEW_MESSAGES, OnViewMessages)
	ON_COMMAND(ID_EMULATION_RESET, OnEmulationReset)
	ON_COMMAND(ID_EMULATION_START, OnEmulationStart)
	ON_COMMAND(ID_EMULATION_STOP, OnEmulationStop)
	ON_COMMAND(ID_VIEW_DIPSWITCHES, OnViewDipswitches)
	ON_COMMAND(ID_VIEW_SETTINGS, OnViewSettings)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_EMULATION_HARDRESET, OnEmulationHardreset)
	ON_COMMAND(ID_VIEW_WINDOW_1X, OnViewWindow1x)
	ON_COMMAND(ID_VIEW_WINDOW_2X, OnViewWindow2x)
	ON_COMMAND(ID_VIEW_WINDOW_3X, OnViewWindow3x)
	ON_COMMAND(ID_VIEW_WINDOW_4X, OnViewWindow4x)
	ON_COMMAND(ID_FILE_SAVESETTINGS, OnFileSavesettings)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBreemApp construction

CBreemApp::CBreemApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
messages.RemoveAll();
emumessage("breem v%s by Dead_Body, built on %s at %s\n",VERSION,__DATE__,__TIME__);
loadsettings();
switch(settings.blitter)
	{
	default:settings.blitter = 0;
	case 0:m_blitter = new gdiblitter;break;
	case 1:m_blitter = new dxblitter;break;
	}
messagesdlg = 0;
debuggerdlg = 0;
romsetinited = 0;
}

CBreemApp::~CBreemApp()
{
m_blitter->kill();
delete m_blitter;
savesettings();
killemu(0);
if(messagesdlg)
	delete messagesdlg;
if(debuggerdlg)
	delete debuggerdlg;
}

#define getcheck_num(rk,c,v,k,d)\
{\
char value[256],*stop;\
u32 valuelen = 256;\
v = d;\
if(rk.QueryValue(value,k,&valuelen) == ERROR_SUCCESS)\
	v = (c)strtol(value,&stop,10);\
}
#define getcheck_str(rk,v,k,d)\
{\
char value[512];\
u32 valuelen = 512;\
strcpy(v,d);\
if(rk.QueryValue(value,k,&valuelen) == ERROR_SUCCESS)\
	strcpy(v,value);\
}
#define setcheck_num(rk,v,k)\
{\
char _value[256];\
sprintf(_value,"%ld",v);\
if(rk.SetKeyValue("",_value,k) != ERROR_SUCCESS)\
	{\
	if(rk.SetKeyValue("",_value,k) != ERROR_SUCCESS)\
		MessageBox(0,"error trying to write key \""k"\" to registry","error",MB_OK);\
	}\
}
#define setcheck_str(rk,v,k)\
{\
if(rk.SetKeyValue("",v,k) != ERROR_SUCCESS)\
	{\
	if(rk.SetKeyValue("",v,k) != ERROR_SUCCESS)\
		MessageBox(0,"error trying to write key \""k"\" to registry","error",MB_OK);\
	}\
}
void CBreemApp::loadsettings()
{
CRegKey key;

if(key.Open(HKEY_CURRENT_USER,"Software\\Dead_Body\\breem\\settings") == ERROR_SUCCESS)
	{
	char curdir[512];

	GetCurrentDirectory(512,curdir);
	getcheck_num(key,u8,settings.blitter,"blitter",0);
	getcheck_num(key,u8,settings.sound,"sound",0);
	getcheck_num(key,int,settings.samplerate,"samplerate",22050);
	getcheck_num(key,u8,settings.framelimit,"framelimit",0);
	getcheck_num(key,int,settings.x,"x",-1);
	getcheck_num(key,int,settings.y,"y",-1);
	getcheck_num(key,int,settings.w,"w",256);
	getcheck_num(key,int,settings.h,"h",256);
	getcheck_num(key,u8,keys.coina,"coina",VK_F1);
	getcheck_num(key,u8,keys.coinb,"coinb",VK_F2);
	getcheck_num(key,u8,keys.start1,"start1",VK_F3);
	getcheck_num(key,u8,keys.start2,"start2",VK_F4);
	getcheck_num(key,u8,keys.up1,"up1",VK_UP);
	getcheck_num(key,u8,keys.down1,"down1",VK_DOWN);
	getcheck_num(key,u8,keys.left1,"left1",VK_LEFT);
	getcheck_num(key,u8,keys.right1,"right1",VK_RIGHT);
	getcheck_num(key,u8,keys.button1,"button1",VK_SPACE);
	key.Close();
	emumessage("settings loaded\n");
	}
else
	{
	settings.btime_dip[0] = 0x3f;
	settings.btime_dip[1] = 0x1f;
	settings.btime2_dip[0] = 0x3f;
	settings.btime2_dip[1] = 0x1f;
	settings.btimem_dip[0] = 0x3f;
	settings.btimem_dip[1] = 0x1f;
	settings.brubber_dip[0] = 0x3f;
	settings.brubber_dip[1] = 0x1f;
	settings.blitter = 0;
	settings.sound = 0;
	settings.samplerate = 22050;
	settings.framelimit = 0;
	settings.x = -1;
	settings.y = -1;
	settings.w = 256;
	settings.h = 256;
	keys.coina = VK_F1;
	keys.coinb = VK_F2;
	keys.start1 = VK_F3;
	keys.start2 = VK_F4;
	keys.up1 = VK_UP;
	keys.down1 = VK_DOWN;
	keys.left1 = VK_LEFT;
	keys.right1 = VK_RIGHT;
	keys.button1 = VK_SPACE;
	emumessage("error loading settings (maybe first time ran?  congratulation!)\n");
	}
}

void CBreemApp::savesettings()
{
CRegKey key;

if(key.Create(HKEY_CURRENT_USER,"Software\\Dead_Body\\breem\\settings") == ERROR_SUCCESS)
	{
	setcheck_num(key,settings.blitter,"blitter");
	setcheck_num(key,settings.sound,"sound");
	setcheck_num(key,settings.samplerate,"samplerate");
	setcheck_num(key,settings.framelimit,"framelimit");
	setcheck_num(key,settings.x,"x");
	setcheck_num(key,settings.y,"y");
	setcheck_num(key,settings.w,"w");
	setcheck_num(key,settings.h,"h");
	setcheck_num(key,keys.coina,"coina");
	setcheck_num(key,keys.coinb,"coinb");
	setcheck_num(key,keys.start1,"start1");
	setcheck_num(key,keys.start2,"start2");
	setcheck_num(key,keys.up1,"up1");
	setcheck_num(key,keys.down1,"down1");
	setcheck_num(key,keys.left1,"left1");
	setcheck_num(key,keys.right1,"right1");
	setcheck_num(key,keys.button1,"button1");
	key.Close();
	emumessage("settings saved\n");
	}
else
	emumessage("error saving settings\n");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBreemApp object

CBreemApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBreemApp initialization

int isin(char *str,char c)
{
while(*str)
	{
	if(*str++ == c)
		return(1);
	}
return(0);
}

BOOL CBreemApp::InitInstance()
{
int i;
char *ptr = m_lpCmdLine;

argc = 0;
for(i=0;i<64;i++)
	argv[i] = 0;
argv[argc] = new char[_MAX_PATH];
GetModuleFileName(0,argv[argc],_MAX_PATH);
GetCurrentDirectory(512,rompathname);
strcpy(romsetname,"");
argc++;
if((ptr = strtok(m_lpCmdLine," ")) != 0)
	{
	for(;;)
		{
		argv[argc] = new char[strlen(ptr)+1];
		strcpy(argv[argc],ptr);
		argc++;
		if((ptr = strtok(0," ")) == 0)
			break;
		if(argc == 64)
			{
			MessageBox(0,"too many command line parameters, what are you doing?","warning",MB_OK);
			break;
			}
		}
	}
for(i=1;i<argc;i++)
	{
	if(strcmpi("-roms",argv[i]) == 0)
		{
		char tempfilename[512];

		i++;
		if(argv[i][0] == '"') //pathname with spaces
			{
			sprintf(tempfilename,"%s ",&argv[i++][1]);
			while(isin(argv[i],'"') == 0)
				{
				strcat(tempfilename,argv[i++]);
				strcat(tempfilename," ");
				}
			strncat(tempfilename,argv[i],strlen(argv[i]) - 1);
			}
		else //pathname without spaces
			strcpy(tempfilename,argv[i]);
		if(tempfilename[1] != ':')
			{
			char curdir[512],*poop;

			GetCurrentDirectory(512,curdir);
			GetFullPathName(tempfilename,512,rompathname,&poop);
			}
		else
			strcpy(rompathname,tempfilename);
		}
	if(strcmpi("-romset",argv[i]) == 0)
		{
		i++;
		if(strchr(argv[i],':') == 0)
			strcpy(romsetname,argv[i]);
		else
			{
			char *p1,*p2,shit[_MAX_PATH],set[12];

			strcpy(shit,argv[i]);
			p1 = shit;
			while(*p1)
				{
				if(*p1 == '/')
					*p1 = '\\';
				p1++;
				}
			if((p1 = strrchr(shit,'\\')) != 0)
				{
				p1++;
				if((p2 = strrchr(p1,'.')) != 0)
					{
					memset(set,0,12);
					memcpy(set,p1,p2 - p1);
					p1--;
					*p1 = 0;
					killemu();
					if(initemu(shit,set) == 0)
						{
						reset();
						startemu();
						}
					else
						killemu();
					}
				}
			}
		}
	else if(strcmpi("-help",argv[i]) == 0 || strcmpi("-h",argv[i]) == 0 || strcmpi("-?",argv[i]) == 0)
		{
		MessageBox(0,
			"-roms pathname = load roms from this dir\n"
			"-romset name   = specify romset (only btime is supported now)\n"
			,"usage",MB_OK);
		return(FALSE);
		}
	}
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Dead_Body"));


	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	pFrame->m_bAutoMenuEnable = 0;

	// create and load the frame with its resources
	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);

	if(settings.x != -1 && settings.y != -1)
		pFrame->SetWindowPos(0,settings.x,settings.y,0,0,SWP_NOZORDER | SWP_NOSIZE);
	pFrame->resizeclient(settings.w,settings.h);

	pFrame->SetWindowText("breem");
	pFrame->SetIcon(LoadIcon(IDR_MAINFRAME),TRUE);

	// The one and only window has been initialized, so show and update it.
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();
	if(m_blitter->init(256,256,256,m_pMainWnd->GetSafeHwnd()) == 0)
		{
		MessageBox(0,"error initing blitter","error",MB_OK|MB_ICONERROR);
		return(FALSE);
		}
	killemu();
	if(strcmp(romsetname,"") != 0)
		{
		if(initemu(rompathname,romsetname) == 0)
			{
			reset();
			startemu();
			}
		else
			killemu();
		}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CBreemApp message handlers





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CLink	m_url;
	CString	m_versionstring;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnUrl();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_versionstring = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_URL, m_url);
	DDX_Text(pDX, IDC_VERSIONSTRING, m_versionstring);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
char *str = "http://www.parodius.com/~deadbody/";

	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
m_versionstring.Format("breem v%s\n",VERSION);
m_url.setparent(this);
m_url.setlinkcolor(0x00ff0000);
m_url.SetWindowText(str);
UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_URL, OnUrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBreemApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CAboutDlg::OnUrl() 
{
	// TODO: Add your control notification handler code here
ShellExecute(0,0,"http://www.parodius.com/~deadbody/",0,0,SW_SHOWMAXIMIZED);
}

/////////////////////////////////////////////////////////////////////////////
// CBreemApp message handlers

extern "C" void setcolor(int n,u8 r,u8 g,u8 b)
{
theApp.m_blitter->setcolor(n,r,g,b);
}

int CBreemApp::initemu(char *pathname,char *set) //rewrite this function
{
char filename[512];
char zipfilename[512];
char str[128];
int i;
CRegKey key;

killemu();
if(setromset(set) != 0)
	return(1);
for(i=0;i<3;i++)
	{
	cpumem[i] = new u8[0x10000];
	memset(cpumem[i],0,0x10000);
	}
vrom[0] = new u8[0x6000];
vrom[1] = new u8[0x2000];
vrom[2] = new u8[0x800];
emumessage("initemu: %s - %s\n",pathname,set);
sprintf(filename,"%s\\%s",pathname,romset->name);
sprintf(zipfilename,"%s.zip",filename);
if(access(zipfilename,04) == 0) //inside zip
	{
	rom_t *rom;
	u8 *mem;
	unzFile file;

	if(romset->parent) //load all the original roms first, if cloned
		{
		unzFile cfile;

		sprintf(filename,"%s\\%s.zip",pathname,romset->parent->name);
		if((cfile = unzOpen(filename)) == 0)
			{
			sprintf(str,"error opening zip file %s.zip, you need this to run this game",romset->parent->name);
			MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
			return(1);
			}
		emumessage("loading parent romset roms: %s\n",filename);
		rom = romset->parent->roms;
		while(rom->filename != 0)
			{
			sprintf(filename,"%s\\%s\\%s",pathname,set,rom->filename);
			if(unzLocateFile(cfile,rom->filename,0) == UNZ_END_OF_LIST_OF_FILE)
				{
				sprintf(str,"error loading rom, %s is missing from set %s zip file",rom->filename,set);
				MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
				return(1);
				}
			if(unzOpenCurrentFile(cfile) != UNZ_OK)
				{
				sprintf(str,"error loading rom, %s couldnt be opened from set %s zip file",rom->filename,set);
				MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
				return(1);
				}
			switch(rom->memplace)
				{
				case CPU1:mem = cpumem[0] + rom->loadaddr;break;
				case CPU2:mem = cpumem[1] + rom->loadaddr;break;
				case VROM1:mem = vrom[0] + rom->loadaddr;break;
				case VROM2:mem = vrom[1] + rom->loadaddr;break;
				case VROM3:mem = vrom[2] + rom->loadaddr;break;
				default:
					mem = 0;
					sprintf(str,"bug: rom->memplace for file %s is bad, or something fucked up your memory, email deadbody@parodius.com and tell me to help you",rom->filename);
					MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
					unzCloseCurrentFile(cfile);
					unzClose(cfile);
					return(1);
				}
			if(unzReadCurrentFile(cfile,mem,rom->size) != (int)rom->size)
				{
				sprintf(str,"error loading rom, %s couldnt be read from set %s zip file",rom->filename,set);
				MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
				unzCloseCurrentFile(cfile);
				return(1);
				}
			unzCloseCurrentFile(cfile);
			rom++;
			}
		unzClose(cfile);
		}
	emumessage("loading romset roms: %s\n",zipfilename);
	strcpy(filename,zipfilename);
	if((file = unzOpen(filename)) == 0)
		{
		sprintf(str,"error opening zip file %s.zip",romset->name);
		MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
		return(1);
		}
	rom = romset->roms;
	while(rom->filename != 0)
		{
		if(unzLocateFile(file,rom->filename,0) == UNZ_END_OF_LIST_OF_FILE)
			{
			sprintf(str,"error loading rom, %s is missing from set %s zip file",rom->filename,set);
			MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
			return(1);
			}
		if(unzOpenCurrentFile(file) != UNZ_OK)
			{
			sprintf(str,"error loading rom, %s couldnt be opened from set %s zip file",rom->filename,set);
			MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
			return(1);
			}
		switch(rom->memplace)
			{
			case CPU1:mem = cpumem[0] + rom->loadaddr;break;
			case CPU2:mem = cpumem[1] + rom->loadaddr;break;
			case VROM1:mem = vrom[0] + rom->loadaddr;break;
			case VROM2:mem = vrom[1] + rom->loadaddr;break;
			case VROM3:mem = vrom[2] + rom->loadaddr;break;
			default:
				mem = 0;
				sprintf(str,"bug: rom->memplace for file %s is bad, or something fucked up my memory, email deadbody@parodius.com and tell me to help you",rom->filename);
				MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
				unzCloseCurrentFile(file);
				unzClose(file);
				return(1);
			}
		if(unzReadCurrentFile(file,mem,rom->size) != (int)rom->size)
			{
			sprintf(str,"error loading rom, %s couldnt be read from set %s zip file",rom->filename,set);
			MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
			unzCloseCurrentFile(file);
			return(1);
			}
		unzCloseCurrentFile(file);
		rom++;
		}
	unzClose(file);
	emumessage("roms loaded ok from zip file\n");
	}
/*else if(access(filename,0) == 0) //inside directory
	{
	FILE *file;
	rom_t *rom;
	u8 *mem;

	if(romset->clone) //load all the original roms first, if cloned
		{
		emumessage("loading original romset roms: %s\n",filename);
		rom = romset->clone->roms;
		while(rom->filename != 0)
			{
			if((file = fopen(filename,"rb")) == 0)
				{
				sprintf(str,"error loading rom, %s is missing from set %s",rom->filename,set);
				MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
				return(1);
				}
			switch(rom->memplace)
				{
				case CPU1:mem = cpumem[0] + rom->loadaddr;break;
				case CPU2:mem = cpumem[1] + rom->loadaddr;break;
				case VROM1:mem = vrom[0] + rom->loadaddr;break;
				case VROM2:mem = vrom[1] + rom->loadaddr;break;
				case VROM3:mem = vrom[2] + rom->loadaddr;break;
				default:
					mem = 0;
					sprintf(str,"bug: rom->memplace for file %s is bad, or something fucked up my memory, email deadbody@parodius.com and tell me to help you",rom->filename);
					MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
					fclose(file);
					return(1);
				}
			fread(mem,rom->size,1,file);
			fclose(file);
			rom++;
			}
		emumessage("loading clone romset roms\n");
		}
	else
		emumessage("loading romset roms\n");
	rom = romset->roms;
	while(rom->filename != 0)
		{
		sprintf(filename,"%s\\%s\\%s",pathname,set,rom->filename);
		if((file = fopen(filename,"rb")) == 0)
			{
			sprintf(str,"error loading rom, %s is missing from set %s",rom->filename,romset->name);
			MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
			return(1);
			}
		switch(rom->memplace)
			{
			case CPU1:mem = cpumem[0] + rom->loadaddr;break;
			case CPU2:mem = cpumem[1] + rom->loadaddr;break;
			case VROM1:mem = vrom[0] + rom->loadaddr;break;
			case VROM2:mem = vrom[1] + rom->loadaddr;break;
			case VROM3:mem = vrom[2] + rom->loadaddr;break;
			default:
				mem = 0;
				sprintf(str,"bug: rom->memplace for file %s is bad, or something fucked up my memory, email deadbody@parodius.com and tell me to help you",rom->filename);
				MessageBox(0,str,"error",MB_OK|MB_ICONERROR);
				fclose(file);
				return(1);
			}
		fread(mem,rom->size,1,file);
		fclose(file);
		rom++;
		}
	emumessage("roms loaded ok from directory\n");
	}*/
else
	{
	MessageBox(0,"error loading roms, file/dir doesnt exist","error",MB_OK|MB_ICONERROR);
	return(1);
	}	
cpu1cycles = SCANLINECYCLES(romset->cpu1hz);
cpu2cycles = SCANLINECYCLES(romset->cpu2hz);
cpu1data.op6502 = romset->readcpu1;
cpu1data.read6502 = romset->readcpu1;
cpu1data.write6502 = romset->writecpu1;
cpu2data.op6502 = romset->readcpu2;
cpu2data.read6502 = romset->readcpu2;
cpu2data.write6502 = romset->writecpu2;
m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_START,MF_ENABLED);
m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_STOP,MF_GRAYED);
m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_RESET,MF_ENABLED);
m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_HARDRESET,MF_ENABLED);
m_pMainWnd->GetMenu()->EnableMenuItem(ID_VIEW_DEBUGGER,MF_ENABLED);
m_pMainWnd->GetMenu()->EnableMenuItem(ID_VIEW_DIPSWITCHES,MF_ENABLED);
sprintf(str,"breem - %s",romsetname);
m_pMainWnd->SetWindowText(str);
emurunning = 0;
for(i=0;i<PAGE_NUM;i++)
	{
	cpu1data.oppages[i] = 0;
	cpu1data.readpages[i] = 0;
	cpu1data.writepages[i] = 0;
	}
strcpy(rompathname,pathname);
/*if(AY8910_initchip(0,1500000,settings.samplerate) != 0)
	{
	MessageBox(0,"error initing ay8910 chip #0","error",MB_OK|MB_ICONERROR);
	return(1);
	}
if(AY8910_initchip(1,1500000,settings.samplerate) != 0)
	{
	MessageBox(0,"error initing ay8910 chip #1","error",MB_OK|MB_ICONERROR);
	return(1);
	}*/
memcpy(cpumem[2],cpumem[0],0x10000);
info.cpu1data = &cpu1data;
info.cpu2data = &cpu2data;
info.romset = romset;
info.cpumem[0] = cpumem[0];
info.cpumem[1] = cpumem[1];
info.cpumem[2] = cpumem[2];
info.vrom[0] = vrom[0];
info.vrom[1] = vrom[1];
info.vrom[2] = vrom[2];
info.input[0] = &reg4000;
info.input[1] = &reg4001;
info.input[2] = &reg4002;
info.vblank = &vblank;
info.setcolor = setcolor;
info.getcurrentopcodepc = getcurrentopcodepc;
info.getnextopcodepc = getnextopcodepc;
info.emumessage = emumessage;
setgameinfo(&info);
if(key.Open(HKEY_CURRENT_USER,"Software\\Dead_Body\\breem\\settings") == ERROR_SUCCESS)
	{
	loaddips(&key);
	key.Close();
	emumessage("dip switches loaded\n");
	}
else
	{
	loaddips(0);
	emumessage("error loading dip switches \n");
	}
romset->init();
romsetinited = 1;
return(0);
}

#define DELETEVAR(v) if(v){delete v;v=0;}
#define DELETEARRAY(v) if(v){delete[] v;v=0;}
void CBreemApp::killemu(int updatemenus)
{
if(romsetinited)
	{
	CRegKey key;

	romset->kill();
	if(key.Create(HKEY_CURRENT_USER,"Software\\Dead_Body\\breem\\dips") == ERROR_SUCCESS)
		{
		savedips(&key);
		key.Close();
		emumessage("dip switches saved\n");
		}
	else
		emumessage("error saving dip switches\n");
	}
romsetinited = 0;
DELETEARRAY(cpumem[0]);
DELETEARRAY(cpumem[1]);
DELETEARRAY(cpumem[2]);
DELETEARRAY(vrom[0]);
DELETEARRAY(vrom[1]);
DELETEARRAY(vrom[2]);
emurunning = 0;
if(updatemenus)
	{
	m_pMainWnd->SetWindowText("breem");
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_START,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_STOP,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_RESET,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_HARDRESET,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_VIEW_DEBUGGER,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_VIEW_DIPSWITCHES,MF_GRAYED);
	}
}

int CBreemApp::setromset(char *name)
{
romset_t *r;
int c;

for(c=0;;c++)
	{
	r = getromsets()[c];
	if(r == 0)
		{
		MessageBox(0,"invalid rom set name","error",MB_OK|MB_ICONERROR);
		return(1);
		}
	if(strcmp(name,r->name) == 0)
		{
		romset = r;
		break;
		}
	}
strcpy(romsetname,name);
return(0);
}

void CBreemApp::reset()
{
set6502data(&cpu1data);
reset6502();
set6502data(&cpu2data);
reset6502();
frames = 0;
vblank = 0x80; //not in vblank
emumessage("reset\n");
}

void CBreemApp::startemu()
{
if(emurunning == 0)
	{
	emurunning = 1;
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_START,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_STOP,MF_ENABLED);
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&c);
	last = c.QuadPart;
	frametime = freq.QuadPart / 57; //57 fps
	}
}

void CBreemApp::stopemu()
{
if(emurunning)
	{
	char newtitle[64];

	emurunning = 0;
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_START,MF_ENABLED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_STOP,MF_GRAYED);
	sprintf(newtitle,"breem - %s",romsetname);
	m_pMainWnd->SetWindowText(newtitle);
	}
}

void CBreemApp::frame()
{
char newtitle[64];
u8 *screen;

for(;;)
	{
	set6502data(&cpu1data);
	if(exec6502(cpu1cycles) & BAD_OPCODE)
		{
		emumessage("main: bad opcode at %04x, stopping emulation",cpu1data.pc);
		stopemu();
		return;
		}
	set6502data(&cpu2data);
	if(exec6502(cpu2cycles) & BAD_OPCODE)
		{
		emumessage("sound: bad opcode at %04x, stopping emulation",cpu2data.pc);
		stopemu();
		return;
		}
	scanline++;
	if(scanline == 240)
		{ //fix this naughty input system
		reg4000 = 0xff;
		reg4001 = 0xff;
		reg4002 = 0x03;
		if(GetAsyncKeyState(keys.coina)){set6502data(&cpu1data);nmi6502();reg4002|=0x40;}
		if(GetAsyncKeyState(keys.coinb)){set6502data(&cpu1data);nmi6502();reg4002|=0x80;}
		if(GetAsyncKeyState(keys.start1)){reg4002&=~0x01;}
		if(GetAsyncKeyState(keys.start2)){reg4002&=~0x02;}
		if(GetAsyncKeyState(keys.right1)){reg4000&=~0x01;}
		if(GetAsyncKeyState(keys.left1)){reg4000&=~0x02;}
		if(GetAsyncKeyState(keys.up1)){reg4000&=~0x04;}
		if(GetAsyncKeyState(keys.down1)){reg4000&=~0x08;}
		if(GetAsyncKeyState(keys.button1)){reg4000&=~0x10;}
		if((screen = m_blitter->framestart()) == 0)
			{
			emumessage("m_blitter->framestart returned 0");
			stopemu();
			return;
			}
		romset->renderscreen(screen);
		m_blitter->framestop();
		vblank = 0;
		}
	else if(scanline == 272) //last scanline
		{
		vblank = 0x80;
		if(settings.framelimit)
			{
			for(;;)
				{
				QueryPerformanceCounter(&c);
				if((c.QuadPart - last) >= frametime)
					break;
				}
			}
		QueryPerformanceCounter(&c);
		if((frames & 0x3f) == 0)
			{
			s64 t = c.QuadPart - last;

			if(t)
				sprintf(newtitle,"breem - %5.1f fps",(float)freq.QuadPart / t);
			m_pMainWnd->SetWindowText(newtitle);
			}
		last = c.QuadPart;
		frames++;
		scanline = 0;
		break;
		}
	}
/*set6502data(&cpu1data);
if(exec6502(cpu1cycles * 240) & BAD_OPCODE)
	{
	emumessage("main: bad opcode at %04x, stopping emulation",cpu1data.pc);
	stopemu();
	m_blitter->framestop();
	return;
	}
set6502data(&cpu2data);
if(exec6502(cpu2cycles * 240) & BAD_OPCODE)
	{
	emumessage("sound: bad opcode at %04x, stopping emulation",cpu2data.pc);
	stopemu();
	m_blitter->framestop();
	return;
	}
romset->renderscreen(screen);
vblank = 0;
set6502data(&cpu1data);
if(exec6502(cpu1cycles * 32) & BAD_OPCODE)
	{
	emumessage("main: bad opcode at %04x, stopping emulation",cpu1data.pc);
	stopemu();
	m_blitter->framestop();
	return;
	}
set6502data(&cpu2data);
if(exec6502(cpu2cycles * 32) & BAD_OPCODE)
	{
	emumessage("sound: bad opcode at %04x, stopping emulation",cpu2data.pc);
	stopemu();
	m_blitter->framestop();
	return;
	}
vblank = 0x80;
if(settings.framelimit)
	{
	for(;;)
		{
		QueryPerformanceCounter(&c);
		if((c.QuadPart - last) >= frametime)
			break;
		}
	}
QueryPerformanceCounter(&c);
if((frames & 0x3f) == 0)
	{
	s64 t = c.QuadPart - last;

	if(t)
		sprintf(newtitle,"breem - %5.1f fps",(float)freq.QuadPart / t);
	m_pMainWnd->SetWindowText(newtitle);
	}
last = c.QuadPart;
frames++;
m_blitter->framestop();*/
}

BOOL CBreemApp::OnIdle(LONG /*lCount*/) 
{
	// TODO: Add your specialized code here and/or call the base class
if(emurunning)
	frame();
else if(romsetinited == 0) //elite game fade out
	{
	int i;

	for(i=0;i<256;i++)
		{
		u8 r,g,b;

		m_blitter->getcolor(i,&r,&g,&b);
		if(r)r--;
		if(g)g--;
		if(b)b--;
		m_blitter->setcolor(i,r,g,b);
		}
	m_blitter->framestart();
	m_blitter->framestop();
	for(;;)
		{
		QueryPerformanceCounter(&c);
		if((c.QuadPart - last) >= frametime)
			break;
		}
	QueryPerformanceCounter(&c);
	last = c.QuadPart;
	}
	return TRUE;//CWinApp::OnIdle(lCount);
}

int CBreemApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
int i;

for(i=0;i<64;i++)
	{
	if(argv[i])
		delete[] argv[i];
	}
	return CWinApp::ExitInstance();
}

void CBreemApp::OnViewRomviewer() 
{
	// TODO: Add your command handler code here
CRomViewer romviewer;

romviewer.setroms(getromsets());
romviewer.DoModal();
}

void CBreemApp::OnViewDebugger() 
{
	// TODO: Add your command handler code here
if(debuggerdlg == 0)
	{
	stopemu();
	debuggerdlg = new CDebugger;
	debuggerdlg->setcontexts(&cpu1data,&cpu2data,romset);
	debuggerdlg->Create(IDD_DEBUGGER,debuggerdlg->GetDesktopWindow());
	debuggerdlg->ShowWindow(SW_SHOW);
	debuggerdlg->SetWindowPos(&debuggerdlg->wndNoTopMost,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE);
	m_pMainWnd->GetMenu()->CheckMenuItem(ID_VIEW_DEBUGGER,MF_CHECKED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_START,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_STOP,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_RESET,MF_GRAYED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_HARDRESET,MF_GRAYED);
	}
else
	{
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_START,MF_ENABLED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_RESET,MF_ENABLED);
	m_pMainWnd->GetMenu()->EnableMenuItem(ID_EMULATION_HARDRESET,MF_ENABLED);
	m_pMainWnd->GetMenu()->CheckMenuItem(ID_VIEW_DEBUGGER,MF_UNCHECKED);
	delete debuggerdlg;
	debuggerdlg = 0;
	}
}

void CBreemApp::OnViewMessages() 
{
	// TODO: Add your command handler code here
if(messagesdlg == 0)
	{
	messagesdlg = new CMessages;
	messagesdlg->Create(IDD_MESSAGES,messagesdlg->GetDesktopWindow());
	messagesdlg->setstringlist(&messages);
	messagesdlg->ShowWindow(SW_SHOW);
	messagesdlg->SetWindowPos(&messagesdlg->wndNoTopMost,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE);
	m_pMainWnd->GetMenu()->CheckMenuItem(ID_VIEW_MESSAGES,MF_CHECKED);
	}
else
	{
	m_pMainWnd->GetMenu()->CheckMenuItem(ID_VIEW_MESSAGES,MF_UNCHECKED);
	delete messagesdlg;
	messagesdlg = 0;
	}
}

void CBreemApp::OnEmulationReset() 
{
	// TODO: Add your command handler code here
reset();
if(debuggerdlg)
	debuggerdlg->refresh();
}

void CBreemApp::OnEmulationStart() 
{
	// TODO: Add your command handler code here
startemu();	
}

void CBreemApp::OnEmulationStop() 
{
	// TODO: Add your command handler code here
stopemu();	
}

void CBreemApp::OnViewDipswitches() 
{
	// TODO: Add your command handler code here
dipsettings();
}

void CBreemApp::OnViewSettings() 
{
	// TODO: Add your command handler code here
CSettings settingsDlg;

settingsDlg.DoModal();
}

void CBreemApp::OnFileOpen() 
{
	// TODO: Add your command handler code here
char fn[_MAX_PATH] = "";
OPENFILENAME dlgdata;
char dir[_MAX_PATH];
char set[12];

strcpy(fn,"");
GetCurrentDirectory(_MAX_PATH,dir);
dlgdata.lStructSize = sizeof(OPENFILENAME);
dlgdata.hwndOwner = m_pMainWnd->GetSafeHwnd();
dlgdata.hInstance = 0;
dlgdata.lpstrFilter = "romsets (*.zip)\0*.zip\0romsets (*.*)\0*.*\0";
dlgdata.lpstrCustomFilter = 0;
dlgdata.nMaxCustFilter = 0;
dlgdata.nFilterIndex = 0;
dlgdata.lpstrFile = fn;
dlgdata.nMaxFile = _MAX_PATH;
dlgdata.lpstrFileTitle = 0;
dlgdata.nMaxFileTitle = 0;
dlgdata.lpstrInitialDir = dir;
dlgdata.lpstrTitle = "open romset";
dlgdata.Flags = OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
dlgdata.nFileOffset = 0;
dlgdata.nFileExtension = 0;
dlgdata.lpstrDefExt = 0;
dlgdata.lCustData = 0;
dlgdata.lpfnHook = 0;
dlgdata.lpTemplateName = 0;
if(GetOpenFileName(&dlgdata))
	{
	char *p1,*p2;

	if((p1 = strrchr(fn,'\\') + 1) == (char*)1)
		return;
	if((p2 = strrchr(p1,'.')) == 0)
		return;
	memset(set,0,12);
	memcpy(set,p1,p2 - p1);
	p1--;
	*p1 = 0;
	killemu();
	if(initemu(fn,set) == 0)
		{
		reset();
		startemu();
		}
	else
		killemu();
	}
}

void CBreemApp::OnEmulationHardreset() 
{
	// TODO: Add your command handler code here
killemu();
if(initemu(rompathname,romsetname) == 0)
	{
	reset();
	startemu();
	}
else
	killemu();	
}

void CBreemApp::OnViewWindow1x() 
{
	// TODO: Add your command handler code here
((CMainFrame*)m_pMainWnd)->resizeclient(256*1,256*1);
}

void CBreemApp::OnViewWindow2x() 
{
	// TODO: Add your command handler code here
((CMainFrame*)m_pMainWnd)->resizeclient(256*2,256*2);
}

void CBreemApp::OnViewWindow3x() 
{
	// TODO: Add your command handler code here
((CMainFrame*)m_pMainWnd)->resizeclient(256*3,256*3);
}

void CBreemApp::OnViewWindow4x() 
{
	// TODO: Add your command handler code here
((CMainFrame*)m_pMainWnd)->resizeclient(256*4,256*4);
}

void CBreemApp::OnFileSavesettings() 
{
	// TODO: Add your command handler code here
savesettings();
}

void CBreemApp::OnFileClose() 
{
	// TODO: Add your command handler code here
killemu();
}
