// breem.h : main header file for the BREEM application
//

#if !defined(AFX_BREEM_H__58FC29A4_6C4D_11D5_BCEA_00A0CCD69DE3__INCLUDED_)
#define AFX_BREEM_H__58FC29A4_6C4D_11D5_BCEA_00A0CCD69DE3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "dead6502\dead6502.h"
#include "types.h"
#include "blitter.h"
#include "messages.h"
#include "debugger.h"

#define VERSION				"1.00"
#define SCANLINECYCLES(hz)	(hz / 57 / 272) //57 refreshs/sec, 272 scanlines

/////////////////////////////////////////////////////////////////////////////
// CBreemApp:
// See breem.cpp for the implementation of this class
//

class CBreemApp : public CWinApp
{
private:
	keys_t keys;
	u32 cpu1cycles,cpu2cycles;
	u64 last,frametime;
	LARGE_INTEGER freq,c;
	u32 frames;
	u16 scanline;
	int argc;
	char *argv[64];
	char rompathname[512];
	char romsetname[32];
	int initemu(char *pathname,char *set);
	void killemu(int updatemenus=1);
	int setromset(char *name);
	void reset();
	void startemu();
	void stopemu();
	void frame();
public:
	u8 emurunning;
	CMessages *messagesdlg;
	CDebugger *debuggerdlg;
	blitter *m_blitter;
	CBreemApp();
	~CBreemApp();
	void loadsettings();
	void savesettings();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBreemApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL OnIdle(LONG lCount);
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

public:
	//{{AFX_MSG(CBreemApp)
	afx_msg void OnAppAbout();
	afx_msg void OnViewDebugger();
	afx_msg void OnViewRomviewer();
	afx_msg void OnViewMessages();
	afx_msg void OnEmulationReset();
	afx_msg void OnEmulationStart();
	afx_msg void OnEmulationStop();
	afx_msg void OnViewDipswitches();
	afx_msg void OnViewSettings();
	afx_msg void OnFileOpen();
	afx_msg void OnEmulationHardreset();
	afx_msg void OnViewWindow1x();
	afx_msg void OnViewWindow2x();
	afx_msg void OnViewWindow3x();
	afx_msg void OnViewWindow4x();
	afx_msg void OnFileSavesettings();
	afx_msg void OnFileClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
extern CBreemApp theApp;
extern settings_t settings;
extern romset_t *romset;
extern dead6502data cpu1data,cpu2data;
extern u8 *cpumem[3];
extern u8 *vrom[3];
extern u8 videocontrol,soundlatch;
extern u8 scroll1,scroll2;
extern u8 vblank;
extern u8 reg4000,reg4001,reg4002;
extern "C" void emumessage(char *msg,...);
/*********************************************************************************************/
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BREEM_H__58FC29A4_6C4D_11D5_BCEA_00A0CCD69DE3__INCLUDED_)
