#ifndef __DEAD6502_H__
#define __DEAD6502_H__
/************************************************************************************************/
#define BAD_OPCODE	0x80000000
#define NMI				0x01
#define IRQ				0x02
#define RESET			0x04
#define PAGE_SIZE		0x0800	//2k page size
#define PAGE_MASK		(PAGE_SIZE - 1)
#define PAGE_SHIFT	11
#define PAGE_NUM		(0x10000 / PAGE_SIZE)
/************************************************************************************************/
typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;
typedef struct /* do not change order of these, only add stuff to bottom */
	{
	byte a; /* accumulator */
	byte x;
	byte y;
	byte s; /* stack pointer */
	byte f; /* flags */
	word pc; /* program counter */
	dword totalcycles;
	byte needirq; /* if we need nmi or irq */
	byte (*op6502)(dword); /* read opcodes only function */
	byte (*read6502)(dword); /* read all but opcodes function */
	void (*write6502)(dword,byte); /* write function */
	byte *oppages[PAGE_NUM];
	byte *readpages[PAGE_NUM];
	byte *writepages[PAGE_NUM];
	} dead6502data;
/************************************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif
word disassembleopcode(char *buffer,word opcodepos);
byte getlastopcode();
word getlastopcodepc();
byte getcurrentopcode();
word getcurrentopcodepc();
byte getnextopcode();
word getnextopcodepc();
word getvector(byte v);
void set6502data(dead6502data *newdata);
void get6502data(dead6502data **newdata);
void nmi6502();
void irq6502();
void reset6502();
dword exec6502(dword cycles);
#ifdef __cplusplus
}
#endif
/************************************************************************************************/
#endif
