#include "games.h"
#include "types.h"
#include "dead6502\dead6502.h"
#include "stdafx.h"
#include "breem.h"
/*********************************************************************************************/
//misc shit
static void setpages(u32 addr,u32 size,u8 *start,u8 **pages)
{
u32 startpage = addr / PAGE_SIZE;
u32 numpages = size / PAGE_SIZE;
u32 i;

for(i=startpage;i<startpage+numpages;i++)
	pages[i] = start + ((i * PAGE_SIZE) - addr);
}
/*********************************************************************************************/
//tile drawers
__inline void drawtile_8x8(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 8;
int i,j;
u8 b0,b1,b2;
u8 *bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<8;j++)
	{
	b0 = *bb[0]++;
	b1 = *bb[1]++;
	b2 = *bb[2]++;
	for(i=8-1;i>=0;i--)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 8;
	}
}

__inline void drawtile_16x16(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8*bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<16;j++)
	{
	b0 = (u16)((*bb[0]) << 0);
	b1 = (u16)((*bb[1]) << 0);
	b2 = (u16)((*bb[2]) << 0);
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]++;
	bb[1]++;
	bb[2]++;
	for(i=16-1;i>=0;i--)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_or_notrans(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[],u8 or)
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8 *bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<16;j++)
	{
	b0 = (u16)((*bb[0]) << 0);
	b1 = (u16)((*bb[1]) << 0);
	b2 = (u16)((*bb[2]) << 0);
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]++;
	bb[1]++;
	bb[2]++;
	for(i=16-1;i>=0;i--)
		*s++ = (u8)((((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2)) | or);
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_flipx(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8*bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<16;j++)
	{
	b0 = (u16)*bb[0];
	b1 = (u16)*bb[1];
	b2 = (u16)*bb[2];
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]++;
	bb[1]++;
	bb[2]++;
	for(i=0;i<16;i++)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_flipy(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8 *bb[3];

bb[0] = b[0] + adder + 15;
bb[1] = b[1] + adder + 15;
bb[2] = b[2] + adder + 15;
for(j=0;j<16;j++)
	{
	b0 = (u16)*bb[0];
	b1 = (u16)*bb[1];
	b2 = (u16)*bb[2];
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]--;
	bb[1]--;
	bb[2]--;
	for(i=16-1;i>=0;i--)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_flipxy(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8*bb[3];

bb[0] = b[0] + adder + 15;
bb[1] = b[1] + adder + 15;
bb[2] = b[2] + adder + 15;
for(j=0;j<16;j++)
	{
	b0 = (u16)*bb[0];
	b1 = (u16)*bb[1];
	b2 = (u16)*bb[2];
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]--;
	bb[1]--;
	bb[2]--;
	for(i=0;i<16;i++)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}
/*********************************************************************************************/
//main cpu reading functions
static u8 btime_cpu1read(u32 addr)
{
switch(addr & 0xfc00)
	{
	case 0x1800: //video ram mirror
		addr &= 0x3ff;
		return(cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1000]);
	case 0x1c00: //color ram mirror
		addr &= 0x3ff;
		return(cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1400]);
	case 0x4000:
		switch(addr)
			{
			case 0x4000: //player 1 input
				return(reg4000);
			case 0x4001: //player 2 input
				return(reg4001);
			case 0x4002: //???
				return(reg4002);
			case 0x4003: //dip switch 1
				return((u8)((romset->dips[0] & 0x7f) | vblank));
			case 0x4004: //dip switch 2
				return(romset->dips[1]);
			}
		//fall thru because its not handled
	default:
		emumessage("main: read from unmapped space at %04X",addr);
	}
return(0);
}

static byte brubber_cpu1read(u32 addr)
{
if(addr >= 0x1000 && addr <= 0x1004)
	{
	switch(addr)
		{
		case 0x1000: //dip switch 1
			return((u8)((romset->dips[0] & 0x7f) | vblank));
		case 0x1001: //dip switch 2
			return(romset->dips[1]);
		case 0x1002: //player 1 input
			return(reg4000);
		case 0x1003: //player 2 input
			return(reg4001);
		case 0x1004: //coins/start buttons
			return((u8)((~reg4002 & 0xc0) | ((reg4002 & 3) << 3) | 0x27));
		}
	}
else if(addr >= 0x4800 && addr < 0x5000)
	{
	switch(addr & 0xfc00)
		{
		case 0x4800: //video ram mirror
			addr &= 0x3ff;
			return(cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x4000]);
		case 0x4c00: //color ram mirror
			addr &= 0x3ff;
			return(cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x4400]);
		}
	}
else
	emumessage("main: read from unmapped space at %04X",addr);
return(0);
}
/*********************************************************************************************/
//main cpu write functions
static void btime_cpu1write(u32 addr,u8 value)
{
u32 tmp;

if(addr == 0x00b6)emumessage("write to $00b6, %02X, %04X (%04X)\n",value,cpu1data.pc,getlastopcodepc());
if(addr < 0x2000)
	{
	switch(addr & 0x1c00)
		{
		case 0x0000: //ram
		case 0x0400:
			cpumem[0][addr] = value;
			break;
		case 0x0c00:
			if(addr < 0x0c10) //palette ram crap
				{
				u8 r,g,b;

				value = (u8)(~value);
				r = (u8)((0x21 * ((value >> 0) & 1)) + (0x47 * ((value >> 1) & 1)) + (0x97 * ((value >> 2) & 1)));
				g = (u8)((0x21 * ((value >> 3) & 1)) + (0x47 * ((value >> 4) & 1)) + (0x97 * ((value >> 5) & 1)));
				b = (u8)((0x47 * ((value >> 6) & 1)) + (0x97 * ((value >> 7) & 1)));
				theApp.m_blitter->setcolor(addr & 0xf,r,g,b);
				cpumem[0][addr] = value;
				break;
				}
		case 0x1000: //video ram
		case 0x1400: //color ram
			cpumem[0][addr] = value;
			break;
		case 0x1800: //video ram mirror
			addr &= 0x3ff;
			cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1000] = value;
			break;
		case 0x1c00: //color ram mirror
			addr &= 0x3ff;
			cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1400] = value;
			break;
		default:
			emumessage("main: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,getcurrentopcodepc());
			break;
		}
	}
else if(addr == 0x4002) //video thing
	videocontrol = value;
else if(addr == 0x4003) //sound latch
	soundlatch = value;
else if(addr == 0x4004) //scroll
	scroll1 = value;
else
	emumessage("main: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,getcurrentopcodepc());
addr = getnextopcodepc();
tmp = getcurrentopcodepc();
if(cpumem[2][tmp] == 0x20)
	addr = cpumem[0][tmp + 1] | (cpumem[0][tmp + 2] << 8);
if((addr & 0x0104) == 0x0104)
	cpumem[2][addr] = (u8)((cpumem[0][addr] & 0x13) | ((cpumem[0][addr] & 0x80) >> 5) | ((cpumem[0][addr] & 0x64) << 1) | ((cpumem[0][addr] & 0x08) << 2));
}

static void brubber_cpu1write(u32 addr,u8 value)
{
if(addr == 0x1001) //video thing
	videocontrol = value;
else if(addr == 0x1002) //sound latch
	soundlatch = value;
else if(addr >= 0x4000 && addr < 0x5000)
	{
	switch(addr & 0xfc00)
		{
		case 0x4800: //video ram mirror
			addr &= 0x3ff;
			cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x4000] = value;
			break;
		case 0x4c00: //color ram mirror
			addr &= 0x3ff;
			cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x4400] = value;
			break;
		}
	}
else if(addr >= 0x5000 && addr <= 0x51ff)
	vrom[2][addr & 0x1ff] = value;
else if(addr == 0x5400)
	scroll1 = value;
else if(addr == 0x5800)
	scroll2 = value;
else if(addr >= 0x5c00 && addr <= 0x5c0f)
	{
	u8 r,g,b;

	value = (u8)(~value);
	r = (u8)((0x21 * ((value >> 0) & 1)) + (0x47 * ((value >> 1) & 1)) + (0x97 * ((value >> 2) & 1)));
	g = (u8)((0x21 * ((value >> 3) & 1)) + (0x47 * ((value >> 4) & 1)) + (0x97 * ((value >> 5) & 1)));
	b = (u8)((0x47 * ((value >> 6) & 1)) + (0x97 * ((value >> 7) & 1)));
	theApp.m_blitter->setcolor(addr & 0xf,r,g,b);
	}
else
	emumessage("main: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,getcurrentopcodepc());
}
/*********************************************************************************************/
//sound cpu read functions
static byte btime_cpu2read(u32 addr)
{
if(addr < 0x0400)
	return(cpumem[1][addr]);
else if((addr & 0xf000) == 0xa000) //sound latch
	return(soundlatch);
else if(addr >= 0xf000)
	return(cpumem[1][addr]);
else
	emumessage("sound: read from unmapped space at %04X",addr);
return(0);
}
/*********************************************************************************************/
//sound cpu write functions
static void btime_cpu2write(u32 addr,u8 value)
{
switch(addr & 0xf000)
	{
	case 0x0000:
		if(addr < 0x0400)
			cpumem[1][addr] = value;
		else
			emumessage("sound: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,getcurrentopcodepc());
		break;
	case 0x2000:
//		AY8910Write(0,1,value);
		break;
	case 0x4000:
//		AY8910Write(0,0,value);
		break;
	case 0x6000:
//		AY8910Write(1,1,value);
		break;
	case 0x8000:
//		AY8910Write(1,0,value);
		break;
	default:
		emumessage("sound: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,getcurrentopcodepc());
		break;
	}
}
/*********************************************************************************************/
//init functions
void btime_init()
{
setpages(0xc000,0x4000,cpumem[2] + 0xc000,cpu1data.oppages); //decrypted opcodes
setpages(0x0000,0x0800,cpumem[0] + 0x0000,cpu1data.readpages); //ram
setpages(0x1000,0x0800,cpumem[0] + 0x1000,cpu1data.readpages); //video ram + color ram
setpages(0xc000,0x4000,cpumem[0] + 0xc000,cpu1data.readpages); //rom
//dont set write pages cause of decryption
}

void btimem_init()
{
setpages(0xb000,0x5000,cpumem[2] + 0xb000,cpu1data.oppages); //decrypted opcodes
setpages(0x0000,0x0800,cpumem[0] + 0x0000,cpu1data.readpages); //ram
setpages(0x1000,0x0800,cpumem[0] + 0x1000,cpu1data.readpages); //video ram + color ram
setpages(0xb000,0x5000,cpumem[0] + 0xb000,cpu1data.readpages); //rom
//dont set write pages cause of decryption
}

static void brubber_init()
{
int i;

for(i=0;i<0x10000;i++) //decrypt the opcodes (and data, but it doesnt matter :P)
	{
	u8 v = cpumem[0][i];

	cpumem[2][i] = (u8)((v & 0x9f) | ((v & 0x20) << 1) | ((v & 0x40) >> 1));
	}
setpages(0xc000,0x4000,cpumem[2] + 0xc000,cpu1data.oppages); //decrypted opcodes
setpages(0x0000,0x0800,cpumem[0] + 0x0000,cpu1data.readpages); //ram
setpages(0x4000,0x0800,cpumem[0] + 0x4000,cpu1data.readpages); //video ram + color ram
setpages(0xc000,0x4000,cpumem[0] + 0xc000,cpu1data.readpages); //rom
}

static void bnj_init()
{
int i;

for(i=0;i<0x10000;i++) //decrypt the opcodes (and data, but it doesnt matter :P)
	{
	u8 v = cpumem[0][i];

	cpumem[2][i] = (u8)((v & 0x9f) | ((v & 0x20) << 1) | ((v & 0x40) >> 1));
	}
setpages(0xa000,0x6000,cpumem[2] + 0xa000,cpu1data.oppages); //decrypted opcodes
setpages(0x0000,0x0800,cpumem[0] + 0x0000,cpu1data.readpages); //ram
setpages(0x4000,0x0800,cpumem[0] + 0x4000,cpu1data.readpages); //video ram + color ram
setpages(0xa000,0x6000,cpumem[0] + 0xa000,cpu1data.readpages); //rom
setpages(0x0000,0x0800,cpumem[0] + 0x0000,cpu1data.writepages); //ram
setpages(0x4000,0x0800,cpumem[0] + 0x4000,cpu1data.writepages); //video ram + color ram
}
/*********************************************************************************************/
//renderers
static void btime_renderscreen(u8 *dest)
{
int offs,i,start,x,y;
u8 *videoram,*colorram;
u8 *b[3];

videoram = cpumem[0] + 0x1000;
colorram = cpumem[0] + 0x1400;
if(scroll1 & 0x10) //draw background
	{
	u8 tilemap[4];
	int scroll = -((scroll1 & 0x03) << 8);

	b[0] = vrom[1] + 0x0000;
	b[1] = vrom[1] + 0x0800;
	b[2] = vrom[1] + 0x1000;
	if(videocontrol & 1)
		start = 0;
	else
		start = 1;
	for(i=0;i<4;i++)
		{
		tilemap[i] = (u8)(start | (scroll1 & 0x04));
		start = (++start & 3);
		}
	for(i=0;i<4;i++,scroll+=256)
		{
		int tileoffset = tilemap[i & 3] * 0x100;

		if(scroll > 256)
			break;
		if(scroll < -256)
			continue;
		for(offs=0;offs<0x100;offs++)
			{
			x = 240 - (16 * (offs / 16) + scroll);
			y = 16 * (offs % 16);
			if(videocontrol & 1)
				{
				x = 240 - x;
				y = 240 - y;
				}
			drawtile_16x16_or_notrans(dest,vrom[2][tileoffset + offs],(u8)x,(u8)y,b,8);
			}
		}
	}
else
	memset(dest,0,256*256);
b[0] = vrom[0] + 0x0000;
b[1] = vrom[0] + 0x2000;
b[2] = vrom[0] + 0x4000;
for(offs=0;offs<0x400;offs++) //draw screen stuff
	{
	int tilenum;

	tilenum = videoram[offs] + 256 * (colorram[offs] & 3);
	x = 31 - (offs / 32);
	y = offs % 32;
	if(videocontrol & 1)
		{
		x = 31 - x;
		y = 31 - y;
		}
	if(x > 0 && x < 31 && y > 0 && y < 31) //dont render the garbage
		drawtile_8x8(dest,tilenum,(u8)(x * 8),(u8)(y * 8),b);
	}
for(i=0,offs=0;i<8;i++,offs+=4*32) //draw 8 sprites
	{
	int flip;

	if((videoram[offs] & 1) == 0)
		continue;
	x = 240 - videoram[offs + (3 * 32)];
	y = 240 - videoram[offs + (2 * 32)];
	flip = videoram[offs] & 6;
	if(videocontrol & 1)
		{
		x = 240 - x;
		y = 240 - y;
		flip = ~flip;
		}
	y -= 1;
	switch(flip & 6)
		{
		case 0:drawtile_16x16(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		case 2:drawtile_16x16_flipy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		case 4:drawtile_16x16_flipx(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		case 6:drawtile_16x16_flipxy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		}
	}
}

static void brubber_renderscreen(u8 *dest)
{
int offs,i,x,y,tilenum,flip;
u8 *videoram,*colorram;
u8 *b[3];

videoram = cpumem[0] + 0x4000;
colorram = cpumem[0] + 0x4400;
if(scroll1) //draw background
	{
	int scroll;

	b[0] = vrom[1] + 0x0000;
	b[1] = vrom[1] + 0x0800;
	b[2] = vrom[1] + 0x1000;
	scroll = ((scroll1 & 0x02) * 128) + 511 - scroll2;
	if((videocontrol & 1) == 0)
		scroll = 767 - scroll;
	for(offs=0;offs<0x200;offs++)
		{
		x = 16 * ((offs < 0x100) ? ((offs % 0x80) / 8) : ((offs % 0x80) / 8) + 16);
		y = 16 * (((offs % 0x100) < 0x80) ? offs % 8 : (offs % 8) + 8);
		x = 496 - x;
		if(videocontrol & 1)
			{
			x = 496 - x;
			y = 240 - y;
			}
		drawtile_16x16_or_notrans(dest,(vrom[2][offs] >> 4) + ((offs & 0x80) >> 3) + 32,(u8)x,(u8)y,b,8);
		}
	b[0] = vrom[0] + 0x0000;
	b[1] = vrom[0] + 0x2000;
	b[2] = vrom[0] + 0x4000;
	for(offs=0;offs<0x400;offs++) //draw screen stuff behind
		{
		tilenum = videoram[offs] + 256 * (colorram[offs] & 3);
		if(tilenum & 0x80) //skip this tile
			continue;
		x = 31 - (offs / 32);
		y = offs % 32;
		if(videocontrol & 1)
			{
			x = 31 - x;
			y = 31 - y;
			}
		if(x > 0 && x < 31 && y > 0 && y < 31) //dont render the garbage
			drawtile_8x8(dest,tilenum,(u8)(x * 8),(u8)(y * 8),b);
		}
	for(i=0,offs=0;i<8;i++,offs+=4*32) //draw 8 sprites
		{
		if((videoram[offs] & 1) == 0)
			continue;
		x = 240 - videoram[offs + (3 * 32)];
		y = 240 - videoram[offs + (2 * 32)];
		flip = videoram[offs] & 6;
		if(videocontrol & 1)
			{
			x = 240 - x;
			y = 240 - y;
			flip = ~flip;
			}
		switch(flip & 6)
			{
			case 0:drawtile_16x16(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			case 2:drawtile_16x16_flipy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			case 4:drawtile_16x16_flipx(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			case 6:drawtile_16x16_flipxy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			}
		}
	for(offs=0;offs<0x400;offs++) //draw screen stuff
		{
		tilenum = videoram[offs] + 256 * (colorram[offs] & 3);
		if((tilenum & 0x80) == 0) //skip this tile
			continue;
		x = 31 - (offs / 32);
		y = offs % 32;
		if(videocontrol & 1)
			{
			x = 31 - x;
			y = 31 - y;
			}
		if(x > 0 && x < 31 && y > 0 && y < 31) //dont render the garbage
			drawtile_8x8(dest,tilenum,(u8)(x * 8),(u8)(y * 8),b);
		}
	}
else
	{
	memset(dest,0,256*256);
	b[0] = vrom[0] + 0x0000;
	b[1] = vrom[0] + 0x2000;
	b[2] = vrom[0] + 0x4000;
	for(offs=0;offs<0x400;offs++) //draw screen stuff
		{
		tilenum = videoram[offs] + 256 * (colorram[offs] & 3);
		x = 31 - (offs / 32);
		y = offs % 32;
		if(videocontrol & 1)
			{
			x = 31 - x;
			y = 31 - y;
			}
		if(x > 0 && x < 31 && y > 0 && y < 31) //dont render the garbage
			drawtile_8x8(dest,tilenum,(u8)(x * 8),(u8)(y * 8),b);
		}
	for(i=0,offs=0;i<8;i++,offs+=4*32) //draw 8 sprites
		{
		if((videoram[offs] & 1) == 0)
			continue;
		x = 240 - videoram[offs + (3 * 32)];
		y = 240 - videoram[offs + (2 * 32)];
		flip = videoram[offs] & 6;
		if(videocontrol & 1)
			{
			x = 240 - x;
			y = 240 - y;
			flip = ~flip;
			}
		switch(flip & 6)
			{
			case 0:drawtile_16x16(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			case 2:drawtile_16x16_flipy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			case 4:drawtile_16x16_flipx(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			case 6:drawtile_16x16_flipxy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
			}
		}
	}
}
/*********************************************************************************************/
static romset_t btime =
	{
	"btime",0,settings.btime_dip,BTIME_DIPSWITCHES,
	1500000,500000,
	btime_cpu1read,btime_cpu2read,
	btime_cpu1write,btime_cpu2write,
	btime_init,btime_renderscreen,
		{
		{0xc000,0x1000,CPU1,"aa04.9b"}, //game roms
		{0xd000,0x1000,CPU1,"aa06.13b"},
		{0xe000,0x1000,CPU1,"aa05.10b"},
		{0xf000,0x1000,CPU1,"aa07.15b"},
		{0xf000,0x1000,CPU2,"ab14.12h"}, //sound cpu rom
		{0x0000,0x1000,VROM1,"aa12.7k"}, //chars
		{0x1000,0x1000,VROM1,"ab13.9k"},
		{0x2000,0x1000,VROM1,"ab10.10k"},
		{0x3000,0x1000,VROM1,"ab11.12k"},
		{0x4000,0x1000,VROM1,"aa8.13k"},
		{0x5000,0x1000,VROM1,"ab9.15k"},
		{0x0000,0x0800,VROM2,"ab00.1b"}, //sprites
		{0x0800,0x0800,VROM2,"ab01.3b"},
		{0x1000,0x0800,VROM2,"ab02.4b"},
		{0x0000,0x0800,VROM3,"ab03.6b"}, //background
		{0,0,0,0}
		}
	};
static romset_t btime2 =
	{
	"btime2",&btime,settings.btime2_dip,BTIME_DIPSWITCHES,
	1500000,500000,
	btime_cpu1read,btime_cpu2read,
	btime_cpu1write,btime_cpu2write,
	btime_init,btime_renderscreen,
		{
		{0xc000,0x1000,CPU1,"aa04.9b2"},
		{0,0,0,0}
		}
	};
static romset_t btimem =
	{
	"btimem",&btime,settings.btimem_dip,BTIME_DIPSWITCHES,
	1500000,500000,
	btime_cpu1read,btime_cpu2read,
	btime_cpu1write,btime_cpu2write,
	btimem_init,btime_renderscreen,
		{
		{0xb000,0x1000,CPU1,"ab05a1.12b"},
		{0xc000,0x1000,CPU1,"ab04.9b"},
		{0xd000,0x1000,CPU1,"ab06.13b"},
		{0xe000,0x1000,CPU1,"ab05.10b"},
		{0xf000,0x1000,CPU1,"ab07.15b"},
		{0,0,0,0}
		}
	};
static romset_t brubber =
	{
	"brubber",0,settings.brubber_dip,NO_DIPSWITCHES,
	750000,500000,
	brubber_cpu1read,btime_cpu2read,
	brubber_cpu1write,btime_cpu2write,
	brubber_init,brubber_renderscreen,
		{
		{0xc000,0x2000,CPU1,"brubber.12c"}, //game roms
		{0xe000,0x2000,CPU1,"brubber.12d"},
		{0xf000,0x1000,CPU2,"bnj6c.bin"}, //sound cpu rom
		{0x0000,0x2000,VROM1,"bnj4e.bin"}, //chars
		{0x2000,0x2000,VROM1,"bnj4f.bin"},
		{0x4000,0x2000,VROM1,"bnj4h.bin"},
		{0x0000,0x1000,VROM2,"bnj10e.bin"}, //sprites
		{0x1000,0x1000,VROM2,"bnj10f.bin"},
		{0,0,0,0}
		}
	};
static romset_t bnj =
	{
	"bnj",&brubber,settings.brubber_dip,NO_DIPSWITCHES,
	750000,500000,
	brubber_cpu1read,btime_cpu2read,
	brubber_cpu1write,btime_cpu2write,
	bnj_init,brubber_renderscreen,
		{
		{0xa000,0x2000,CPU1,"bnj12b.bin"},
		{0xc000,0x2000,CPU1,"bnj12c.bin"},
		{0xe000,0x2000,CPU1,"bnj12d.bin"},
		{0,0,0,0}
		}
	};
static romset_t caractn =
	{
	"caractn",&brubber,settings.brubber_dip,NO_DIPSWITCHES,
	750000,500000,
	brubber_cpu1read,btime_cpu2read,
	brubber_cpu1write,btime_cpu2write,
	brubber_init,brubber_renderscreen,
		{
		{0xe000,0x2000,CPU1,"caractn.a6"},
		{0x0000,0x2000,VROM1,"caractn.a0"},
		{0x2000,0x2000,VROM1,"caractn.a1"},
		{0x4000,0x2000,VROM1,"caractn.a2"},
		{0,0,0,0}
		}
	};
romset_t *romsets[] = {&btime,&btime2,&btimem,&brubber,&bnj,&caractn,0};
/*********************************************************************************************/
