// btime_DipSwitches.cpp : implementation file
//

#include "stdafx.h"
#include "..\types.h"
#include "resource.h"
#include "games.h"
#include "btime_DipSwitches.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char *coinstr[] = {"2 coins/1 credit","1 coin/3 credits","1 coin/2 credits","1 coin/1 credit"};

/////////////////////////////////////////////////////////////////////////////
// Cbtime_DipSwitches dialog


Cbtime_DipSwitches::Cbtime_DipSwitches(CWnd* pParent /*=NULL*/)
	: CDialog(Cbtime_DipSwitches::IDD, pParent)
{
	//{{AFX_DATA_INIT(Cbtime_DipSwitches)
	m_crosshatch = FALSE;
	m_endoflevelpepper = FALSE;
	m_servicemode = FALSE;
	m_dip1 = _T("");
	m_dip2 = _T("");
	//}}AFX_DATA_INIT
}


void Cbtime_DipSwitches::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Cbtime_DipSwitches)
	DDX_Control(pDX, IDC_LIVES, m_lives);
	DDX_Control(pDX, IDC_ENEMIES, m_enemies);
	DDX_Control(pDX, IDC_CABINET, m_cabinet);
	DDX_Control(pDX, IDC_BONUSLIFE, m_bonuslife);
	DDX_Control(pDX, IDC_COINB, m_coinb);
	DDX_Control(pDX, IDC_COINA, m_coina);
	DDX_Check(pDX, IDC_CROSSHATCH, m_crosshatch);
	DDX_Check(pDX, IDC_ENDOFLEVELPEPPER, m_endoflevelpepper);
	DDX_Check(pDX, IDC_SERVICEMODE, m_servicemode);
	DDX_Text(pDX, IDC_DIP1, m_dip1);
	DDV_MaxChars(pDX, m_dip1, 4);
	DDX_Text(pDX, IDC_DIP2, m_dip2);
	DDV_MaxChars(pDX, m_dip2, 4);
	//}}AFX_DATA_MAP
}

void Cbtime_DipSwitches::updateshit(int what)
{
if(what == 0) //update dialog controls
	{
	m_coina.SetCurSel(dip1 & 3);
	m_coinb.SetCurSel((dip1 >> 2) & 3);
	m_servicemode = (~(dip1 >> 4)) & 1;
	m_crosshatch = (~(dip1 >> 5)) & 1;
	m_cabinet.SetCurSel((dip1 >> 6) & 1);
	m_lives.SetCurSel(dip2 & 1);
	m_bonuslife.SetCurSel((dip2 >> 1) & 3);
	m_enemies.SetCurSel((dip2 >> 3) & 1);
	m_endoflevelpepper = (~(dip2 >> 4)) & 1;
	}
else //update dip switch edits/vars
	{
	UpdateData(TRUE);
	dip1 = 0;
	dip2 = 0;
	dip1 |= m_coina.GetCurSel() & 3;
	dip1 |= (m_coinb.GetCurSel() & 3) << 2;
	if(m_servicemode == 0)
		dip1 |= 0x10;
	if(m_crosshatch == 0)
		dip1 |= 0x20;
	dip1 |= (m_cabinet.GetCurSel() & 1) << 6;
	dip2 |= m_lives.GetCurSel() & 1;
	dip2 |= (m_bonuslife.GetCurSel() & 3) << 1;
	dip2 |= (m_enemies.GetCurSel() & 1) << 3;
	if(m_endoflevelpepper == 0)
		dip2 |= 0x10;
	m_dip1.Format("$%02X",dip1);
	m_dip2.Format("$%02X",dip2);
	}
UpdateData(FALSE);
}

BEGIN_MESSAGE_MAP(Cbtime_DipSwitches, CDialog)
	//{{AFX_MSG_MAP(Cbtime_DipSwitches)
	ON_EN_CHANGE(IDC_DIP1, OnChangeDip1)
	ON_EN_CHANGE(IDC_DIP2, OnChangeDip2)
	ON_BN_CLICKED(IDC_SERVICEMODE, OnServicemode)
	ON_BN_CLICKED(IDC_CROSSHATCH, OnCrosshatch)
	ON_BN_CLICKED(IDC_ENDOFLEVELPEPPER, OnEndoflevelpepper)
	ON_CBN_SELCHANGE(IDC_COINA, OnSelchangeCoina)
	ON_CBN_SELCHANGE(IDC_COINB, OnSelchangeCoinb)
	ON_CBN_SELCHANGE(IDC_CABINET, OnSelchangeCabinet)
	ON_CBN_SELCHANGE(IDC_LIVES, OnSelchangeLives)
	ON_CBN_SELCHANGE(IDC_BONUSLIFE, OnSelchangeBonuslife)
	ON_CBN_SELCHANGE(IDC_ENEMIES, OnSelchangeEnemies)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Cbtime_DipSwitches message handlers

void Cbtime_DipSwitches::OnOK() 
{
	// TODO: Add extra validation here
dips[0] = (u8)(dip1 & ~0x80);
dips[1] = dip2;
	CDialog::OnOK();
}

BOOL Cbtime_DipSwitches::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
dip1 = (u8)(dips[0] & ~0x80);
dip2 = dips[1];
m_coina.AddString(coinstr[0]);
m_coina.AddString(coinstr[1]);
m_coina.AddString(coinstr[2]);
m_coina.AddString(coinstr[3]);
m_coinb.AddString(coinstr[0]);
m_coinb.AddString(coinstr[1]);
m_coinb.AddString(coinstr[2]);
m_coinb.AddString(coinstr[3]);
m_cabinet.AddString("upright");
m_cabinet.AddString("cocktail");
m_lives.AddString("5");
m_lives.AddString("3");
m_bonuslife.AddString("30000");
m_bonuslife.AddString("20000");
m_bonuslife.AddString("15000");
m_bonuslife.AddString("10000");
m_enemies.AddString("6");
m_enemies.AddString("4");
m_dip1.Format("$%02X",dip1);
m_dip2.Format("$%02X",dip2);
updateshit();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Cbtime_DipSwitches::OnChangeDip1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
char *p,*stop;
int base = 10;

UpdateData(TRUE);
p = m_dip1.GetBuffer(512);
if(strcmp(p,"") != 0)
	{
	if(*p == '$')
		{
		p++;
		base = 16;
		}
	else if((*p == '0' && (*(p+1) == 'x') || (*p == '0' && *(p+1) == 'X')))
		{
		p += 2;
		base = 16;
		}
	dip1 = (u8)strtol(p,&stop,base);
	updateshit();
	}
}

void Cbtime_DipSwitches::OnChangeDip2() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
char *p,*stop;
int base = 10;

UpdateData(TRUE);
p = m_dip2.GetBuffer(512);
if(strcmp(p,"") != 0)
	{
	if(*p == '$')
		{
		p++;
		base = 16;
		}
	else if((*p == '0' && (*(p+1) == 'x') || (*p == '0' && *(p+1) == 'X')))
		{
		p += 2;
		base = 16;
		}
	dip2 = (u8)strtol(p,&stop,base);
	updateshit();
	}
}

void Cbtime_DipSwitches::OnServicemode() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnCrosshatch() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnEndoflevelpepper() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnSelchangeCoina() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnSelchangeCoinb() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnSelchangeCabinet() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnSelchangeLives() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnSelchangeBonuslife() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}

void Cbtime_DipSwitches::OnSelchangeEnemies() 
{
	// TODO: Add your control notification handler code here
updateshit(1);
}
