#include "stdafx.h"
#include "games.h"
#include "..\types.h"
/*********************************************************************************************/
u8 dips[2];
gameinfo_t *gameinfo;
static u8 videocontrol,soundlatch;
static u8 scroll1,scroll2;
/*********************************************************************************************/
//misc shit
static void setpages(u32 addr,u32 size,u8 *start,u8 **pages)
{
u32 startpage = addr / PAGE_SIZE;
u32 numpages = size / PAGE_SIZE;
u32 i;

for(i=startpage;i<startpage+numpages;i++)
	pages[i] = start + ((i * PAGE_SIZE) - addr);
}
/*********************************************************************************************/
//tile drawers
__inline void drawtile_8x8(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 8;
int i,j;
u8 b0,b1,b2;
u8 *bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<8;j++)
	{
	b0 = *bb[0]++;
	b1 = *bb[1]++;
	b2 = *bb[2]++;
	for(i=8-1;i>=0;i--)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 8;
	}
}

__inline void drawtile_16x16(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8*bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<16;j++)
	{
	b0 = (u16)((*bb[0]) << 0);
	b1 = (u16)((*bb[1]) << 0);
	b2 = (u16)((*bb[2]) << 0);
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]++;
	bb[1]++;
	bb[2]++;
	for(i=16-1;i>=0;i--)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_or_notrans(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[],u8 or)
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8 *bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<16;j++)
	{
	b0 = (u16)((*bb[0]) << 0);
	b1 = (u16)((*bb[1]) << 0);
	b2 = (u16)((*bb[2]) << 0);
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]++;
	bb[1]++;
	bb[2]++;
	for(i=16-1;i>=0;i--)
		*s++ = (u8)((((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2)) | or);
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_flipx(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8*bb[3];

bb[0] = b[0] + adder;
bb[1] = b[1] + adder;
bb[2] = b[2] + adder;
for(j=0;j<16;j++)
	{
	b0 = (u16)*bb[0];
	b1 = (u16)*bb[1];
	b2 = (u16)*bb[2];
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]++;
	bb[1]++;
	bb[2]++;
	for(i=0;i<16;i++)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_flipy(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8 *bb[3];

bb[0] = b[0] + adder + 15;
bb[1] = b[1] + adder + 15;
bb[2] = b[2] + adder + 15;
for(j=0;j<16;j++)
	{
	b0 = (u16)*bb[0];
	b1 = (u16)*bb[1];
	b2 = (u16)*bb[2];
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]--;
	bb[1]--;
	bb[2]--;
	for(i=16-1;i>=0;i--)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}

__inline void drawtile_16x16_flipxy(u8 *dest,int tilenum,u8 x,u8 y,u8 *b[])
{
u8 *s = dest + x + (y * 256);
u32 adder = tilenum * 32;
int i,j;
u16 b0,b1,b2;
u8*bb[3];

bb[0] = b[0] + adder + 15;
bb[1] = b[1] + adder + 15;
bb[2] = b[2] + adder + 15;
for(j=0;j<16;j++)
	{
	b0 = (u16)*bb[0];
	b1 = (u16)*bb[1];
	b2 = (u16)*bb[2];
	b0 |= (u16)((*(bb[0] + 16)) << 8);
	b1 |= (u16)((*(bb[1] + 16)) << 8);
	b2 |= (u16)((*(bb[2] + 16)) << 8);
	bb[0]--;
	bb[1]--;
	bb[2]--;
	for(i=0;i<16;i++)
		{
		u8 color = (u8)(((b0 >> i) & 1) | (((b1 >> i) & 1) << 1) | (((b2 >> i) & 1) << 2));

		if(color)
			*s++ = color;
		else
			s++;
		}
	s += 256 - 16;
	}
}
/*********************************************************************************************/
//main cpu reading functions
static u8 btime_cpu1read(u32 addr)
{
switch(addr & 0xfc00)
	{
	case 0x1800: //video ram mirror
		addr &= 0x3ff;
		return(gameinfo->cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1000]);
	case 0x1c00: //color ram mirror
		addr &= 0x3ff;
		return(gameinfo->cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1400]);
	case 0x4000:
		switch(addr)
			{
			case 0x4000: //player 1 input
				return(*gameinfo->input[0]);
			case 0x4001: //player 2 input
				return(*gameinfo->input[1]);
			case 0x4002: //coin/start
				return(*gameinfo->input[2]);
			case 0x4003: //dip switch 1
				return((u8)((dips[0] & 0x7f) | *gameinfo->vblank));
			case 0x4004: //dip switch 2
				return(dips[1]);
			}
		//fall thru because its not handled
	default:
		gameinfo->emumessage("main: read from unmapped space at %04X",addr);
	}
return(0);
}
/*********************************************************************************************/
//main cpu write functions
static void btime_cpu1write(u32 addr,u8 value)
{
u32 tmp;

if(addr < 0x2000)
	{
	switch(addr & 0x1c00)
		{
		case 0x0000: //ram
		case 0x0400:
			gameinfo->cpumem[0][addr] = value;
			break;
		case 0x0c00:
			if(addr < 0x0c10) //palette ram crap
				{
				u8 r,g,b;

				value = (u8)(~value);
				r = (u8)((0x21 * ((value >> 0) & 1)) + (0x47 * ((value >> 1) & 1)) + (0x97 * ((value >> 2) & 1)));
				g = (u8)((0x21 * ((value >> 3) & 1)) + (0x47 * ((value >> 4) & 1)) + (0x97 * ((value >> 5) & 1)));
				b = (u8)((0x47 * ((value >> 6) & 1)) + (0x97 * ((value >> 7) & 1)));
				gameinfo->setcolor(addr & 0xf,r,g,b);
				gameinfo->cpumem[0][addr] = value;
				break;
				}
		case 0x1000: //video ram
		case 0x1400: //color ram
			gameinfo->cpumem[0][addr] = value;
			break;
		case 0x1800: //video ram mirror
			addr &= 0x3ff;
			gameinfo->cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1000] = value;
			break;
		case 0x1c00: //color ram mirror
			addr &= 0x3ff;
			gameinfo->cpumem[0][(((addr % 32) * 32) + (addr / 32)) | 0x1400] = value;
			break;
		default:
			gameinfo->emumessage("main: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,gameinfo->getcurrentopcodepc());
			break;
		}
	}
else if(addr == 0x4002) //video thing
	videocontrol = value;
else if(addr == 0x4003) //sound latch
	soundlatch = value;
else if(addr == 0x4004) //scroll
	scroll1 = value;
else
	gameinfo->emumessage("main: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,gameinfo->getcurrentopcodepc());
addr = gameinfo->getnextopcodepc();
tmp = gameinfo->getcurrentopcodepc();
if(gameinfo->cpumem[2][tmp] == 0x20)
	addr = gameinfo->cpumem[0][tmp + 1] | (gameinfo->cpumem[0][tmp + 2] << 8);
if((addr & 0x0104) == 0x0104)
	gameinfo->cpumem[2][addr] = (u8)((gameinfo->cpumem[0][addr] & 0x13) | ((gameinfo->cpumem[0][addr] & 0x80) >> 5) | ((gameinfo->cpumem[0][addr] & 0x64) << 1) | ((gameinfo->cpumem[0][addr] & 0x08) << 2));
}
/*********************************************************************************************/
//sound cpu read functions
static byte btime_cpu2read(u32 addr)
{
if(addr < 0x0400)
	return(gameinfo->cpumem[1][addr]);
else if((addr & 0xf000) == 0xa000) //sound latch
	return(soundlatch);
else if(addr >= 0xf000)
	return(gameinfo->cpumem[1][addr]);
else
	gameinfo->emumessage("sound: read from unmapped space at %04X",addr);
return(0);
}
/*********************************************************************************************/
//sound cpu write functions
static void btime_cpu2write(u32 addr,u8 value)
{
switch(addr & 0xf000)
	{
	case 0x0000:
		if(addr < 0x0400)
			gameinfo->cpumem[1][addr] = value;
		else
			gameinfo->emumessage("sound: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,gameinfo->getcurrentopcodepc());
		break;
	case 0x2000:
//		AY8910Write(0,1,value);
		break;
	case 0x4000:
//		AY8910Write(0,0,value);
		break;
	case 0x6000:
//		AY8910Write(1,1,value);
		break;
	case 0x8000:
//		AY8910Write(1,0,value);
		break;
	default:
		gameinfo->emumessage("sound: bad write to %04X, value = %02X (pc = %04X)\n",addr,value,gameinfo->getcurrentopcodepc());
		break;
	}
}
/*********************************************************************************************/
//init functions
void btime_init()
{
setpages(0xc000,0x4000,gameinfo->cpumem[2] + 0xc000,gameinfo->cpu1data->oppages); //decrypted opcodes
setpages(0x0000,0x0800,gameinfo->cpumem[0] + 0x0000,gameinfo->cpu1data->readpages); //ram
setpages(0x1000,0x0800,gameinfo->cpumem[0] + 0x1000,gameinfo->cpu1data->readpages); //video ram + color ram
setpages(0xc000,0x4000,gameinfo->cpumem[0] + 0xc000,gameinfo->cpu1data->readpages); //rom
//dont set write pages cause of decryption
videocontrol = 0;
soundlatch = 0;
}

void btimem_init()
{
setpages(0xb000,0x5000,gameinfo->cpumem[2] + 0xb000,gameinfo->cpu1data->oppages); //decrypted opcodes
setpages(0x0000,0x0800,gameinfo->cpumem[0] + 0x0000,gameinfo->cpu1data->readpages); //ram
setpages(0x1000,0x0800,gameinfo->cpumem[0] + 0x1000,gameinfo->cpu1data->readpages); //video ram + color ram
setpages(0xb000,0x5000,gameinfo->cpumem[0] + 0xb000,gameinfo->cpu1data->readpages); //rom
//dont set write pages cause of decryption
videocontrol = 0;
soundlatch = 0;
}
/*********************************************************************************************/
//kill funcs
static void btime_kill()
{

}
/*********************************************************************************************/
//renderers
static void btime_renderscreen(u8 *dest)
{
int offs,i,start,x,y;
u8 *videoram,*colorram;
u8 *b[3];

videoram = gameinfo->cpumem[0] + 0x1000;
colorram = gameinfo->cpumem[0] + 0x1400;
if(scroll1 & 0x10) //draw background
	{
	u8 tilemap[4];
	int scroll = -((scroll1 & 0x03) << 8);

	b[0] = gameinfo->vrom[1] + 0x0000;
	b[1] = gameinfo->vrom[1] + 0x0800;
	b[2] = gameinfo->vrom[1] + 0x1000;
	if(videocontrol & 1)
		start = 0;
	else
		start = 1;
	for(i=0;i<4;i++)
		{
		tilemap[i] = (u8)(start | (scroll1 & 0x04));
		start = (++start & 3);
		}
	for(i=0;i<4;i++,scroll+=256)
		{
		int tileoffset = tilemap[i & 3] * 0x100;

		if(scroll > 256)
			break;
		if(scroll < -256)
			continue;
		for(offs=0;offs<0x100;offs++)
			{
			x = 240 - (16 * (offs / 16) + scroll);
			y = 16 * (offs % 16);
			if(videocontrol & 1)
				{
				x = 240 - x;
				y = 240 - y;
				}
			drawtile_16x16_or_notrans(dest,gameinfo->vrom[2][tileoffset + offs],(u8)x,(u8)y,b,8);
			}
		}
	}
else
	memset(dest,0,256*256);
b[0] = gameinfo->vrom[0] + 0x0000;
b[1] = gameinfo->vrom[0] + 0x2000;
b[2] = gameinfo->vrom[0] + 0x4000;
for(offs=0;offs<0x400;offs++) //draw screen stuff
	{
	int tilenum;

	tilenum = videoram[offs] + 256 * (colorram[offs] & 3);
	x = 31 - (offs / 32);
	y = offs % 32;
	if(videocontrol & 1)
		{
		x = 31 - x;
		y = 31 - y;
		}
	if(x > 0 && x < 31 && y > 0 && y < 31) //dont render the garbage
		drawtile_8x8(dest,tilenum,(u8)(x * 8),(u8)(y * 8),b);
	}
for(i=0,offs=0;i<8;i++,offs+=4*32) //draw 8 sprites
	{
	int flip;

	if((videoram[offs] & 1) == 0)
		continue;
	x = 240 - videoram[offs + (3 * 32)];
	y = 240 - videoram[offs + (2 * 32)];
	flip = videoram[offs] & 6;
	if(videocontrol & 1)
		{
		x = 240 - x;
		y = 240 - y;
		flip = ~flip;
		}
	y -= 1;
	switch(flip & 6)
		{
		case 0:drawtile_16x16(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		case 2:drawtile_16x16_flipy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		case 4:drawtile_16x16_flipx(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		case 6:drawtile_16x16_flipxy(dest,videoram[offs + 32],(u8)x,(u8)y,b);break;
		}
	}
}
/*********************************************************************************************/
static romset_t btime =
	{
	"btime",0,BTIME_DIPSWITCHES,{0x3f,0x1f},
	1500000,500000,
	btime_cpu1read,btime_cpu2read,
	btime_cpu1write,btime_cpu2write,
	btime_init,btime_kill,
	btime_renderscreen,
		{
		{0xc000,0x1000,CPU1,"aa04.9b"}, //game roms
		{0xd000,0x1000,CPU1,"aa06.13b"},
		{0xe000,0x1000,CPU1,"aa05.10b"},
		{0xf000,0x1000,CPU1,"aa07.15b"},
		{0xf000,0x1000,CPU2,"ab14.12h"}, //sound cpu rom
		{0x0000,0x1000,VROM1,"aa12.7k"}, //chars
		{0x1000,0x1000,VROM1,"ab13.9k"},
		{0x2000,0x1000,VROM1,"ab10.10k"},
		{0x3000,0x1000,VROM1,"ab11.12k"},
		{0x4000,0x1000,VROM1,"aa8.13k"},
		{0x5000,0x1000,VROM1,"ab9.15k"},
		{0x0000,0x0800,VROM2,"ab00.1b"}, //sprites
		{0x0800,0x0800,VROM2,"ab01.3b"},
		{0x1000,0x0800,VROM2,"ab02.4b"},
		{0x0000,0x0800,VROM3,"ab03.6b"}, //background
		{0,0,0,0}
		}
	};
static romset_t btime2 =
	{
	"btime2",&btime,BTIME_DIPSWITCHES,{0x3f,0x1f},
	1500000,500000,
	btime_cpu1read,btime_cpu2read,
	btime_cpu1write,btime_cpu2write,
	btime_init,btime_kill,
	btime_renderscreen,
		{
		{0xc000,0x1000,CPU1,"aa04.9b2"},
		{0,0,0,0}
		}
	};
static romset_t btimem =
	{
	"btimem",&btime,BTIME_DIPSWITCHES,{0x3f,0x1f},
	1500000,500000,
	btime_cpu1read,btime_cpu2read,
	btime_cpu1write,btime_cpu2write,
	btimem_init,btime_kill,
	btime_renderscreen,
		{
		{0xb000,0x1000,CPU1,"ab05a1.12b"},
		{0xc000,0x1000,CPU1,"ab04.9b"},
		{0xd000,0x1000,CPU1,"ab06.13b"},
		{0xe000,0x1000,CPU1,"ab05.10b"},
		{0xf000,0x1000,CPU1,"ab07.15b"},
		{0,0,0,0}
		}
	};
romset_t *romsets[] = {&btime,&btime2,&btimem,0};
/*********************************************************************************************/
//exports
extern "C" void setgameinfo(gameinfo_t *info)
{
gameinfo = info;
}
/*********************************************************************************************/
extern "C" romset_t **getromsets()
{
return(romsets);
}
/*********************************************************************************************/
