#ifndef __TYPES_H__
#define __TYPES_H__
/*********************************************************************************************/
#include "dead6502\dead6502.h"
/*********************************************************************************************/
#define CPU1						1
#define CPU2						2
#define VROM1						3
#define VROM2						4
#define VROM3						5
#define NO_DIPSWITCHES			0
#define BTIME_DIPSWITCHES		1
#define BRUBBER_DIPSWITCHES	2
/*********************************************************************************************/
typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;
typedef unsigned __int64 u64;
typedef signed char s8;
typedef signed short s16;
typedef signed long s32;
typedef signed __int64 s64;
typedef struct rom_s
	{
	u16 loadaddr;
	u16 size;
	u8 memplace;
	char *filename;
	} rom_t;
typedef struct romset_s
	{
	char name[12];
	struct romset_s *parent; //pointer to parent rom set
	u8 dialog; //dip switch setttings dialog to use
	u8 defaultdip[2]; //default dip switch settings
	u32 cpu1hz,cpu2hz;
	u8 (*readcpu1)(u32);
	u8 (*readcpu2)(u32);
	void (*writecpu1)(u32,u8);
	void (*writecpu2)(u32,u8);
	void (*init)();
	void (*kill)();
	void (*renderscreen)(u8*);
	rom_t roms[16];
	} romset_t;
typedef struct settings_s
	{
	u8 btime_dip[2];
	u8 btime2_dip[2];
	u8 btimem_dip[2];
	u8 brubber_dip[2];
	u8 framelimit;
	u8 blitter;
	u8 sound;
	int samplerate;
	int x,y,w,h;
	} settings_t;
typedef struct keys_s
	{
	u8 coina,coinb;
	u8 start1,start2;
	u8 up1,down1,left1,right1,button1;
	u8 up2,down2,left2,right2,button2;
	} keys_t;
typedef struct gameinfo_s
	{
	dead6502data *cpu1data,*cpu2data;
	romset_t *romset;
	u8 *cpumem[3];
	u8 *vrom[3];
	u8 *input[3]; //input 1, input 2, and coin input (pointers to u8's)
	u8 *vblank; //pointer to the vblank var
	void (*setcolor)(int,u8,u8,u8);
	word (*getcurrentopcodepc)();
	word (*getnextopcodepc)();
	void (*emumessage)(char*,...);
	} gameinfo_t;
/*********************************************************************************************/
#endif